Subject: bug#50067: Context menus

From: Dmitry Gutov <[email-masked]>
Date: Tue, 31 Aug 2021 23:23:43 +0300

On 31.08.2021 19:56, Juri Linkov wrote:
>>>>> All right. You still prefer the original patch, then?
>>>> Yes, the original patch satisfies my needs, AFAICT.  It would be good
>>>> to hear from Juri as well, though.
>>> Sorry, I can't find the original patch.  This bug#50067 collected
>>> so many different things, so it's now hard to find anything.
>>
>> Here it is: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=50067#183
> 
> Oh, I thought there were two patches: the patch above and also
> the original patch.  But it the above is the original patch,
> then I'd recommend to add more already discussed additions,
> so the new option could provide at least these choices:
> 
> 1. 'jump': Jump to the first location by selecting its window;
> 2. 'show': Show the first item, but keep focus in the Xref window;
> 3. 'move': Move point to the first item in the Xref window
>     without showing it (maybe this should be the default behavior).

We can do that. Do you expect to be using more than 1 of these values 
yourself, or is it just for completeness?

Regarding 3 as default, it makes a certain sense, but then you won't be 
able to iterate through all locations with just 'n'. You'd have to press 
'C-o' and then 'n', 'n', 'n'...

> To be able to add later a similar variable for xref-find-references,
> the new variable for xref-find-definitions could be named accordingly
> with a name that refers to xref-find-definitions, for example,
> xref-find-definitions-auto-jump.  Then later xref-find-references-auto-jump.

I think the "other" variable would be called something with the word 
"xrefs", not "references", and apply to other commands as well, such as 
xref-find-apropos and project-find-regexp.

So the proposed scheme would not quite work. Maybe like this instead?

  - xref-auto-jump-to-first-definition
  - xref-auto-jump-to-first-<xref/item/match/result>. Or just 
xref-auto-jump-to-first.